const jwt = require('jsonwebtoken')
const bcrypt = require('bcrypt');
const saltRounds = 10;

const config = require("../../config")
const mongo = require("../mongoHelp.js")


userObj = require("../storageObjects/userObj")
User = require("../classes/userClass")

function register(name,password){
  return new Promise((resolve,reject) => {
    bcrypt.hash(password, saltRounds).then(hash => {
      mongo.get("algoZoo", "users", {name: name}).then(userArr => {
        if (userArr.length != 0){
          return reject("User exists")
        } else {
          let user = new User(name,hash)
          resolve(makeAuthToken(user._id,user.name))
        }
      })
    })
  })
}

// register("Nobody", "StrongPass")
// register("dabbott", config.secret)


exports.register = register

function login(name,password){
  return new Promise((resolve,reject) => {
    mongo.get("algoZoo", "users", {name: name}).then(userArr => {
      
      userArr.forEach(userDetail => {
        if (name == userDetail.name){
          
            bcrypt.compare(password, userDetail.pass).then(res => {
              if (res) {
                if (!userObj[name]){
                  new User(userDetail.name, userDetail.pass, userDetail._id, userDetail.energy, userDetail.powers)
                  
                } else {
                  userObj[name].readyState = true
                }
                resolve(makeAuthToken(userDetail._id, userDetail.name))
              } 
          }).catch(e => {reject(e)})
        }          
      })

      // todo: looks like the foreach is being asyncy but it shouldn't be, so we're adding a time out, even if it's wrong

      setTimeout(() => {
        reject("x")
      }, 3000);
      
    })
    
  })
}

exports.login = login

function makeAuthToken(id, name){

  return jwt.sign({
    data: {
      id: id,
      name: name
    }
  }, config.secret, { expiresIn: '48h' })
}


function getUser(name){
  if (userObj[name] !== undefined){
    clone = JSON.parse(JSON.stringify(userObj[name]))
    delete clone.password
    return clone
  } else {
    return {}
  }

}

exports.getUser = getUser